<?php

require 'assets/php/models/Room.php';

class TimeSlot
{
    protected DateTime $start;
    protected DateTime $end;
    protected ?Room $room = null;

    public function __set(string $name, mixed $value): void
    {
        if (is_null($this->room))
            $this->room = new Room();

        switch ($name) {
            case 'id':
                $this->room->id = $value;
                break;

            case 'type':
                $this->room->type = $value;
                break;

            case 'location':
                $this->room->location = $value;
                break;

            case 'start_time':
                $this->start = new DateTime($value);
                break;

            case 'end_time':
                $this->end = new DateTime($value);
                break;
            
            case 'room':
                $this->room = $value;
                break;

            default:
                break;
        }
    }

    public function __get($name) : mixed
    {
        if (property_exists($this, $name))
            return $this->$name;
    }

    public function display(): void
    {
        $room_name = $this->room->id;
        $location = $this->room->location;
        $type = $this->room->type;
        $start_time = $this->start->format('H:i');
        $end_time = $this->end->format('H:i');

        include("assets/php/result.php");
    }

    public function cut(TimeSlot $slot) : array
    {
        $ss_diff = $this->start->diff($slot->start);
        $se_diff = $this->start->diff($slot->end);
        $es_diff = $this->end->diff($slot->start);
        $ee_diff = $this->end->diff($slot->end);

        return [$$ss_diff, $se_diff, $es_diff, $ee_diff];
    }
}
